function WeaponFactoryTweakData:cufcw_setup_underbarrel( weapon_id, weapon_name, weapon_mod_id, weapon_mod_name, new_unit, material_config, stance_name, stance_mod_cufcw )
	if self[weapon_id] then
		if self.parts[weapon_mod_id] then
			self[weapon_id].override = self[weapon_id].override or {}

			self[weapon_id].override[weapon_mod_id] = {
				unit = new_unit
			}

			self[weapon_id].uses_parts = self[weapon_id].uses_parts or {}
			
			table.insert( self[weapon_id].uses_parts, weapon_mod_id )
			
			self.parts[weapon_mod_id].weapon_hold_override = self.parts[weapon_mod_id].weapon_hold_override or {}
				
			self.parts[weapon_mod_id].weapon_hold_override[weapon_name] = "contraband"
			self.parts[weapon_mod_id].weapon_hold_override[weapon_mod_name] = "contraband"

			self.parts[weapon_mod_id].weapon_stance_override = self.parts[weapon_mod_id].weapon_stance_override or {}
				
			self.parts[weapon_mod_id].weapon_stance_override[weapon_name] = stance_name
			--self.parts[weapon_mod_id].weapon_stance_override[weapon_mod_name] = stance_name -- add a modified stance at some point

			self.parts[weapon_mod_id].weapon_reload_override = self.parts[weapon_mod_id].weapon_reload_override or {}
			
			if UnderbarrelWeaponsPackAnimsInstalled then
				self.parts[weapon_mod_id].weapon_reload_override[weapon_name] = stance_name
			end
			self.parts[weapon_mod_id].weapon_reload_override[weapon_mod_name] = "contraband"

			if stance_mod_cufcw then
				self:cufcw_check_override( "part", weapon_mod_id )
				
				self.parts[weapon_mod_id].override.wpn_fps_upg_o_45rds = self.parts[weapon_mod_id].override.wpn_fps_upg_o_45rds or {}
				self.parts[weapon_mod_id].override.wpn_fps_upg_o_45rds.stance_mod = self.parts[weapon_mod_id].override.wpn_fps_upg_o_45rds.stance_mod or {}

				self.parts[weapon_mod_id].override.wpn_fps_upg_o_45rds_v2 = self.parts[weapon_mod_id].override.wpn_fps_upg_o_45rds_v2 or {}
				self.parts[weapon_mod_id].override.wpn_fps_upg_o_45rds_v2.stance_mod = self.parts[weapon_mod_id].override.wpn_fps_upg_o_45rds_v2.stance_mod or {}

				self.parts[weapon_mod_id].override.wpn_fps_upg_o_45rds.stance_mod[weapon_id] = stance_mod_cufcw
				self.parts[weapon_mod_id].override.wpn_fps_upg_o_45rds_v2.stance_mod[weapon_id] = stance_mod_cufcw
			end

			self.parts[weapon_mod_id].material_config = Idstring(material_config)
			self.parts[weapon_mod_id].thq_material_config = Idstring(material_config .. "_thq")
			self.parts[weapon_mod_id].cc_thq_material_config = Idstring(material_config .. "_cc_thq")
			self.parts[weapon_mod_id].cc_material_config = Idstring(material_config .. "_cc")
		end
	end
end

function WeaponFactoryTweakData:cufcw_setup_forbid( mod_one, mod_two ) 
	if self.parts[mod_one] and self.parts[mod_two] then
		if not self.parts[mod_one].forbids then
			self.parts[mod_one].forbids = {}
		end
		table.insert(self.parts[mod_one].forbids, mod_two)
	end

	if self.parts[mod_two] and self.parts[mod_one] then
		if not self.parts[mod_two].forbids then
			self.parts[mod_two].forbids = {}
		end
		table.insert(self.parts[mod_two].forbids, mod_one)
	end
end

function WeaponFactoryTweakData:cufcw_check_override( mod_type, mod_woa ) 
	if mod_type == "wpn" then
		if self[mod_woa] then
			self[mod_woa].override = self[mod_woa].override or {}
		end
	elseif mod_type == "part" then
		if self.parts[mod_woa] then
			self.parts[mod_woa].override = self.parts[mod_woa].override or {}
		end
	end
end

--[[
Hooks:PostHook(WeaponFactoryTweakData, "create_bonuses", "CUFCWModInit", function(self)

end)--]]